/***********************************************************************************

  BlackJack v0.2b for PSP
  Copyright 2005 GlobWare.com
  6/19/2005 v0.1
  6/20/2005 v0.2
  6/20/2005 v0.2b
  6/24/2005 v0.2b1 by CraVavr3
  					-Added background table image
	    			-Added Double Down
 						-Added Game Status Totals
 						-Change Blackjack rules to pay 3 to 1
  6/25/2005 - Fixed gameplay legend area's
						v0.2b2 by CraVavr3
						- Changed Double Down to RAISE legend
						- Added POT Total
						- Correct Double Down calculations
						- Added 3 decks ( now better randomising of cards :p )
	6/26/2005 - If 5 Cards passes to dealer
						- If 21 passes to dealer
						- if bust dealer just flips cards rather then continue game
						- Added Tie Totals
						- Fixed Raise to negative if not enough in cash
						- Added 5 Cards as winner	
	6/27/2005 - Added Insurance 
	6/28/2005 - added insurance for display	
	6/29/2005 - fix unlimited cards
            - RULES insurance = + 1/2 initial bet if dealer get BJ pays out x 2, if not you loose bet + insurance to dealer or win initial bet *2 not with insurance
            - Fixed Display
            - 0.2b3 by CraVavr3 
  7/06/2005 - 0.2b4 by CraVavr3 Released
  					- Changed Name to PSPBlackJack
  
  areas copyright their respective owners

  solid.c

***********************************************************************************/

/***********************************************************************************

  Module :	SOLID.c

  Description :	

  Last Modified $Date: $

  $Revision: $

  Copyright (C) 28 May 2005 T Swann

***********************************************************************************/

//**********************************************************************************
//   Include Files
//**********************************************************************************

#include "Types.h"
#include "Graphics.h"
#include <string.h>
#include "Controller.h"
#include "bitmap.c"

//-= Function Definitions =- 

#define O_RDONLY    0x0001 
#define O_WRONLY    0x0002 
#define O_RDWR      0x0003 
#define O_NBLOCK    0x0010 
#define O_APPEND    0x0100 
#define O_CREAT     0x0200 
#define O_TRUNC     0x0400 
#define O_NOWAIT    0x8000 

#define DEBUG_X		400
#define DEBUG_Y		256

#define WINDOW_XPOS	10

// File Manager
int sceIoOpen(const char* file, int mode); 
void sceIoClose(int fd); 
int sceIoRead(int fd, void *data, int size); 
int sceIoWrite(int fd, void *data, int size); 
int sceIoLseek(int fd, int offset, int whence); 
int sceIoRemove(const char *file); 
int sceIoMkdir(const char *dir, int mode); 
int sceIoRmdir(const char *dir); 

// My Routines
void	BuildDeck(void);
void	MasterShuffle(void); 
void	DrawCard(int player);
void	PlayDeckShuffle(void);
void	DisplayPlayerHand();
void	CacheKey();

int		CalcPlayer(void);
int		CalcDealer(void);
u32 	dealw,playw,tiew;

void	DisplayDealerHand();
void	ProcessGameCmd();

void	ProcessInput();
void	DisplayGameInstructions();
void	DisplayGameStatus();
void	DoDealerTurn();
void	DetermineWinner();
void	DisplayCard(int cardnum,int player,int x,int y);

int sceKernelCreateThread(const char* name, void *func, int initPriority, int stacksize, void *arg, int option);
int sceKernelStartThread(int thid, int arg0, int arg1);
int sceKernelSleepThread(void);
int sceKernelRegisterExitCallback(int cbid);
int sceKernelCreateCallback(const char *name, void *func);
void sceKernelPollCallbacks(void);
void sceKernelExitGame(void);



//**********************************************************************************
//   Local Constants
//**********************************************************************************

enum {
	GS_INIT,
	GS_BET,
	GS_STOREBET,
	GS_DEAL,
	GS_PLAYERTURN,
	GS_SHOWDEALER,
	GS_DEALERTURN,
	GS_RESULTS,
	GS_PAYOFF,
	GS_EXITGAME,
	GS_REFRESH,
	GS_GAMESAVED,
	GS_IDLE

} GAMESTATES;

//**********************************************************************************
//   Static Prototypes
//**********************************************************************************
void	__exit();

//**********************************************************************************
//   Global Variables
//**********************************************************************************

u32		g_Cash=0;
u32		g_Bet=0;
u32   g_Insurance=0;
u32   g_Raise=0;

s32		g_MinsPlayed;
s32		g_StartTick;

u32		g_CacheKey;

int		g_GameState;
int		g_GameCmd;
int		lastkey=0;

int		g_automode=0;		

int		g_CheatCash;
int		g_StartCash;

int		g_Winner;
int 	checkdouble,checktie;
char	dealerdeck[156][12];
char	playerdeck[156][12];
char	playdeck[156][12];
char	decktrash[156][12];

char	decktemp[1][12];

int		DeckCards, DealerCards, PlayerCards, TrashCards;

char    deck[156][12]={"AC","2C","3C","4C","5C","6C","7C","8C","9C","10C","JC","QC","KC", 
					 "AD","2D","3D","4D","5D","6D","7D","8D","9D","10D","JD","QD","KD", 
					 "AH","2H","3H","4H","5H","6H","7H","8H","9H","10H","JH","QH","KH", 
					 "AS","2S","3S","4S","5S","6S","7S","8S","9S","10S","JS","QS","KS",
           "AC","2C","3C","4C","5C","6C","7C","8C","9C","10C","JC","QC","KC", 
					 "AD","2D","3D","4D","5D","6D","7D","8D","9D","10D","JD","QD","KD", 
					 "AH","2H","3H","4H","5H","6H","7H","8H","9H","10H","JH","QH","KH", 
					 "AS","2S","3S","4S","5S","6S","7S","8S","9S","10S","JS","QS","KS",
           "AC","2C","3C","4C","5C","6C","7C","8C","9C","10C","JC","QC","KC", 
					 "AD","2D","3D","4D","5D","6D","7D","8D","9D","10D","JD","QD","KD", 
					 "AH","2H","3H","4H","5H","6H","7H","8H","9H","10H","JH","QH","KH", 
					 "AS","2S","3S","4S","5S","6S","7S","8S","9S","10S","JS","QS","KS"};

//**********************************************************************************
//   Static Variables
//**********************************************************************************
static char		s_StringBuffer[ 1024 ];

// insurace check insur == 'A' for ACE
char insur;
int insur_count;
int check_dealerblackjack;
int insur_instructions;

//*************************************************************************************
// Generic Random Number Generator
//*************************************************************************************
							
// get a num rand(l,h)  (rnd % (h-1)) + l
static unsigned long next = 1;

int rand(void)
{
    next = next * 1103515245 + 12345;
    return ((unsigned int) (next / 65536UL) % 32767UL);
}

void srand(unsigned int seed)
{
    next = seed;
}


//*************************************************************************************
// ProcessGameCmd
// main game handler/renderer
//*************************************************************************************
void	ProcessGameCmd()
{
	int	playerscore;
	u32 result32;	
	
		CacheKey();

		pgFillvram( 0x0000 );

		if( g_GameCmd == GS_INIT )
		{			
			g_CheatCash = 1000;
			g_StartCash = 5000;
			g_GameCmd = GS_BET;
			g_Cash = g_StartCash;
			g_Bet = 0;
	
		}
		
		else if( g_GameCmd == GS_BET )
		{
			// Reset all flags and settings
			g_GameState = g_GameCmd;
			g_Winner=0;
			insur = 'B';
      insur_count = 0;
      insur_instructions = 0;
			check_dealerblackjack = 0;
			g_Insurance=0;
			g_Raise = 0;
			if( g_Bet > g_Cash )
			{
				g_Bet = g_Cash;
			}
			// Display status
	
	  DisplayGameStatus();
	

		}
		else if( g_GameCmd == GS_STOREBET )
		{
			g_GameCmd = GS_DEAL;
		}
		else if( g_GameCmd == GS_DEAL )
		{
			g_automode = 0;
			PlayerCards=0;
			DealerCards=0;

			// Draw Cards 1=player, 2=dealer
			DrawCard(1);						
			DrawCard(2);						
			DrawCard(1);						
			DrawCard(2);

			g_GameState = g_GameCmd;
			g_GameCmd = GS_PLAYERTURN;						

			g_Cash -= g_Bet;

		}
	
// Player Turn Commands
		else if( g_GameCmd == GS_PLAYERTURN )
		{
			playerscore = CalcPlayer();
			// Check for Player Blackjack
			if (( playerscore == 21 )||( playerscore > 21  )||( PlayerCards == 5 && playerscore < 21))
			{
				g_automode = 1;
				g_GameCmd = GS_SHOWDEALER;
			}	
		  
		  // allow for insurnce if dealer shows A and checks for dealer BJ
			else if ( check_dealerblackjack == 1 )
			{	
				if 	( CalcDealer() == 21 )
					{
						if ( insur == 'A' )
							{	
							check_dealerblackjack = 2;
							g_GameCmd = GS_SHOWDEALER;
			  			}
				
					
		 		}
		 		check_dealerblackjack = 2;
					insur_instructions = 2;
		 			insur = 'B';
					g_GameState = g_GameCmd;
 				//	g_GameCmd = GS_PLAYERTURN;
		} 
	
				else if( ( PlayerCards == 2) && ( insur == 'A' )  && (insur_count == 0))
				{
  					// display insurance options	
  					insur_instructions = 1;
  		      g_GameState = g_GameCmd;
        }	
			 	else if  (( PlayerCards == 2)	&& ( insur != 'A'))
		//	 	 	else if  ( PlayerCards == 2)	
		
						{	
      			pgBitBlt(WINDOW_XPOS+365,95,16,16,1,image_btn_triangle);
	    			pgPrint( WINDOW_XPOS+379,100,0xffff,"=DOUBLE", 0xA0);
      			g_GameState = g_GameCmd;
            }
        
       	else
       	{
       	g_GameState = g_GameCmd;				
			 	}
		}

// Dealer Turn Commands
		else if( g_GameCmd == GS_SHOWDEALER )
		{
			g_GameState = GS_DEALERTURN;
			g_GameCmd = GS_DEALERTURN;
		}
		else if( g_GameCmd == GS_DEALERTURN )
		{
			g_GameState = g_GameCmd;			
			playerscore = CalcPlayer();
			if  ( playerscore == 21 && PlayerCards == 2) 
			{
				//skip dealers turn on bj
				g_GameState = GS_RESULTS;				
				DetermineWinner();
			}
			else if (PlayerCards==5 && playerscore <= 21)
				{
				g_GameState = GS_RESULTS;				
				DetermineWinner();
				}
			
			else
			{
				DoDealerTurn();			
			}
		}
		else if( g_GameCmd == GS_RESULTS )
		{
			g_GameState = g_GameCmd;			
			DetermineWinner();
			
		}
		else if( g_GameCmd == GS_PAYOFF )
		{
			if( g_Winner == 1 )
			{
				playerscore = CalcPlayer();
				
				// Player Blackjack wins 3 to 1
				if( playerscore == 21 && PlayerCards == 2)
				{
					result32 = g_Bet*3; // was / 2;
		      g_Cash += result32; // BJ pays 1.5
				
				}
				else
					{
						
					// Check if insurance taken	
					if (( insur_instructions ==  2)&& ( g_Insurance != 0 ) && ( DealerCards == 2 ) && ( insur == 'A') && (   CalcDealer() == 21    ))
					//  {
					    // If dealer blackjack and insurance pay 2 times bet and insurance
					 //   if ( g_Insurance != 0 ) && ( DealerCards == 2 ) && ( insur == 'A')
					    	{
					  	   g_Cash += g_Bet*2 + g_Insurance*2;
					      }
					 // }
					// if no insurace or insurance and no blakcjack by dealer payout normal  
					else
						{
					  g_Cash += g_Bet*2 + g_Raise*2;
				    }
				  }
			        playw=playw+1;						
			 } 
			
			// When Tier Just replace bet and raise to cash
			else if( g_Winner == 0 )
			{
				g_Cash += g_Bet + g_Raise;
				tiew=tiew+1;
			}
			
			g_GameCmd = GS_BET;
		}




		
		else if( g_GameCmd == GS_EXITGAME )
		{

		}
		else if( g_GameCmd == GS_REFRESH )
		{
			g_GameCmd = GS_IDLE;
		}
				
		DisplayGameInstructions();			
    DisplayDealerHand();
		DisplayPlayerHand();
		pgPrint( WINDOW_XPOS, 5, 0xffff, "PSPBlackJack v0.2b4 by GlobWare.com moded by CraVavr3", 0xFF );
				
	
		CacheKey();

		pgScreenFlipV();		
		
}

//*************************************************************************************
// DisplayGameStatus
// draws help info on screen
//*************************************************************************************
void	DisplayGameStatus()
{
		pgPrint( WINDOW_XPOS+355, 20, 0xffff, "Cash  $", 0xFF );
		pgPrint( WINDOW_XPOS+415, 20, 0xffff, NumberToAscii( g_Cash, s_StringBuffer ), 0xFF );
		pgPrint( WINDOW_XPOS+355, 30, 0xffff, "Bet   $", 0xFF );
		pgPrint( WINDOW_XPOS+420, 30, 0xffff, NumberToAscii( g_Bet, s_StringBuffer ), 0xFF );
		pgPrint( WINDOW_XPOS+359,180,0xffff,"TOTAL WINS", 0xA0);
		pgPrint( WINDOW_XPOS+359,190,0xffff,"DEALER:", 0xA0);
		pgPrint( WINDOW_XPOS+420,190, 0xffff, NumberToAscii( dealw, s_StringBuffer ), 0xFF );
		pgPrint( WINDOW_XPOS+359,200,0xffff,"PLAYER:", 0xA0);
		pgPrint( WINDOW_XPOS+420,200, 0xffff, NumberToAscii( playw, s_StringBuffer ), 0xFF );
	  pgPrint( WINDOW_XPOS+359,210,0xffff,"TIE:", 0xA0);
		pgPrint( WINDOW_XPOS+420,210, 0xffff, NumberToAscii( tiew, s_StringBuffer ), 0xFF );
	
}



//*************************************************************************************
// DisplayGameInstructions
// draws help info on screen
//*************************************************************************************
void	DisplayGameInstructions()
{
	
 pgBitBlt(0,20,348,247,1,img_Background);	


	// display instruction text and flip screen
	if( g_GameState <= GS_BET )
	{
		pgBitBlt(WINDOW_XPOS+355,125,16,16,1,image_btn_cross);
		pgPrint( WINDOW_XPOS+369,130,0xffff,"=Deal", 0xA0);

		pgBitBlt(WINDOW_XPOS+355,60,6,16,1,image_btn_left);		
		pgBitBlt(WINDOW_XPOS+365,60,6,16,1,image_btn_right);
		pgPrint( WINDOW_XPOS+375,65,0xffff,"=-/+$1", 0xA0);

		pgBitBlt(WINDOW_XPOS+359,75,9,8,1,image_btn_up);
		pgBitBlt(WINDOW_XPOS+359,83,9,8,1,image_btn_down);
		pgPrint( WINDOW_XPOS+375,80,0xffff,"=+/-$100", 0xA0);


	}	
	else if( g_GameState == GS_DEALERTURN || g_GameState == GS_SHOWDEALER )
	{		
		pgBitBlt(WINDOW_XPOS+355,115,16,16,1,image_btn_cross);
		pgPrint( WINDOW_XPOS+369,120,0xffff,"=Next", 0xA0);

		pgBitBlt(WINDOW_XPOS+355,135,16,16,1,image_btn_circle);
		pgPrint( WINDOW_XPOS+369,140,0xffff,"=Continous", 0xA0);

	}
	else if( g_GameState > GS_DEALERTURN )
	{
		
		pgBitBlt(WINDOW_XPOS+110,153,16,16,1,image_btn_cross);
		pgPrint( WINDOW_XPOS+124,158,0xffff,"=NEW GAME", 0xA0);

	}
	else
	{
	  if ( insur_instructions == 1 )
	  	{
	  	pgPrint( WINDOW_XPOS+359,100,0xffff,"INSURANCE", 0xA0);
  		pgBitBlt(WINDOW_XPOS+365,120,16,16,1,image_btn_square);
	    pgPrint( WINDOW_XPOS+379,125,0xffff," = YES", 0xA0);
	    pgBitBlt(WINDOW_XPOS+365,140,16,16,1,image_btn_triangle);
	    pgPrint( WINDOW_XPOS+379,145,0xffff," = NO", 0xA0);
  		}
		else
			{
			pgBitBlt(WINDOW_XPOS+365,115,16,16,1,image_btn_cross);
			pgPrint( WINDOW_XPOS+379,120,0xffff,"=Hit", 0xA0);

			pgBitBlt(WINDOW_XPOS+365,135,16,16,1,image_btn_circle);
			pgPrint( WINDOW_XPOS+379,140,0xffff,"=Stand", 0xA0);
 			}
	}
	
	pgPrint( WINDOW_XPOS+365, 250, 0xffff, "START=EXIT", 0x80);

	
	
   if ((g_Winner != 0 ) ||(g_Winner == 0 && checktie == 1 )) 
	{
  	int x;
  	for(x=0;x<29;x++)
		{
			pgBitBlt(x*11+10,121,16,16,1,image_debug);		
			pgBitBlt(x*11+10,137,16,16,1,image_debug);		
			pgBitBlt(x*11+10,153,16,16,1,image_debug);		
	//		pgBitBlt(x*11+10,169,16,16,1,image_debug);		
		}

    DetermineWinner();
    pgBitBlt(WINDOW_XPOS+110,153,16,16,1,image_btn_cross);
		pgPrint( WINDOW_XPOS+124,158,0xffff,"=NEW GAME", 0xA0);
		
	}

}

//*************************************************************************************
// DisplayPlayerCard
// draw player card
// place graphics here in future
//*************************************************************************************
void DisplayCard(int cardnum,int player,int x,int y)
{
	char card;	
	char face;
	// Set flag to store dealers displayed card at initial deal
  insur = dealerdeck[1][0];
	if( player == 1 )
	{	
		card = playerdeck[cardnum][0];		
		if( card == '1' )
		{
			face = playerdeck[cardnum][2];
		}
		else
		{
			face = playerdeck[cardnum][1];
		}		
	}
	else if( player == 2 )
	{
		if( cardnum == 999 )	// draw back side of card to hide it
		{
			face=' ';
			card=' ';
			pgBitBlt(x,y,55,74,1,img_B);
		}
		else
		{
			card = dealerdeck[cardnum][0];	
	
			if ( card == '1' ) 
			{
				face = dealerdeck[cardnum][2];
			}
			else
			{
				face = dealerdeck[cardnum][1];
			}		
		}
	}

	if( face == 'C' )
	{
		switch( card )
		{
			case 'A':
				pgBitBlt(x,y,55,74,1,img_AC);
				break;
			case '2':
				pgBitBlt(x,y,55,74,1,img_2C);
				break;
			case '3':
				pgBitBlt(x,y,55,74,1,img_3C);
				break;
			case '4':
				pgBitBlt(x,y,55,74,1,img_4C);
				break;
			case '5':
				pgBitBlt(x,y,55,74,1,img_5C);
				break;
			case '6':
				pgBitBlt(x,y,55,74,1,img_6C);
				break;
			case '7':
				pgBitBlt(x,y,55,74,1,img_7C);
				break;
			case '8':
				pgBitBlt(x,y,55,74,1,img_8C);
				break;
			case '9':
				pgBitBlt(x,y,55,74,1,img_9C);
				break;
			case '1':
				pgBitBlt(x,y,55,74,1,img_10C);
				break;
			case 'J':
				pgBitBlt(x,y,55,74,1,img_JC);
				break;
			case 'Q':
				pgBitBlt(x,y,55,74,1,img_QC);
				break;
			case 'K':
				pgBitBlt(x,y,55,74,1,img_KC);
				break;
		}		
	}
	else if( face == 'D' )
	{
		switch( card )
		{
			case 'A':
				pgBitBlt(x,y,55,74,1,img_AD);
				break;
			case '2':
				pgBitBlt(x,y,55,74,1,img_2D);
				break;
			case '3':
				pgBitBlt(x,y,55,74,1,img_3D);
				break;
			case '4':
				pgBitBlt(x,y,55,74,1,img_4D);
				break;
			case '5':
				pgBitBlt(x,y,55,74,1,img_5D);
				break;
			case '6':
				pgBitBlt(x,y,55,74,1,img_6D);
				break;
			case '7':
				pgBitBlt(x,y,55,74,1,img_7D);
				break;
			case '8':
				pgBitBlt(x,y,55,74,1,img_8D);
				break;
			case '9':
				pgBitBlt(x,y,55,74,1,img_9D);
				break;
			case '1':
				pgBitBlt(x,y,55,74,1,img_10D);
				break;
			case 'J':
				pgBitBlt(x,y,55,74,1,img_JD);
				break;
			case 'Q':
				pgBitBlt(x,y,55,74,1,img_QD);
				break;
			case 'K':
				pgBitBlt(x,y,55,74,1,img_KD);
				break;
		}		
	}
	else if( face == 'H' )
	{
		switch( card )
		{
			case 'A':
				pgBitBlt(x,y,55,74,1,img_AH);
				break;
			case '2':
				pgBitBlt(x,y,55,74,1,img_2H);
				break;
			case '3':
				pgBitBlt(x,y,55,74,1,img_3H);
				break;
			case '4':
				pgBitBlt(x,y,55,74,1,img_4H);
				break;
			case '5':
				pgBitBlt(x,y,55,74,1,img_5H);
				break;
			case '6':
				pgBitBlt(x,y,55,74,1,img_6H);
				break;
			case '7':
				pgBitBlt(x,y,55,74,1,img_7H);
				break;
			case '8':
				pgBitBlt(x,y,55,74,1,img_8H);
				break;
			case '9':
				pgBitBlt(x,y,55,74,1,img_9H);
				break;
			case '1':
				pgBitBlt(x,y,55,74,1,img_10H);
				break;
			case 'J':
				pgBitBlt(x,y,55,74,1,img_JH);
				break;
			case 'Q':
				pgBitBlt(x,y,55,74,1,img_QH);
				break;
			case 'K':
				pgBitBlt(x,y,55,74,1,img_KH);
				break;
		}		
	}
	else if( face == 'S' )
	{
		switch( card )
		{
			case 'A':
				pgBitBlt(x,y,55,74,1,img_AS);
				break;
			case '2':
				pgBitBlt(x,y,55,74,1,img_2S);
				break;
			case '3':
				pgBitBlt(x,y,55,74,1,img_3S);
				break;
			case '4':
				pgBitBlt(x,y,55,74,1,img_4S);
				break;
			case '5':
				pgBitBlt(x,y,55,74,1,img_5S);
				break;
			case '6':
				pgBitBlt(x,y,55,74,1,img_6S);
				break;
			case '7':
				pgBitBlt(x,y,55,74,1,img_7S);
				break;
			case '8':
				pgBitBlt(x,y,55,74,1,img_8S);
				break;
			case '9':
				pgBitBlt(x,y,55,74,1,img_9S);
				break;
			case '1':
				pgBitBlt(x,y,55,74,1,img_10S);
				break;
			case 'J':
				pgBitBlt(x,y,55,74,1,img_JS);
				break;
			case 'Q':
				pgBitBlt(x,y,55,74,1,img_QS);
				break;
			case 'K':
				pgBitBlt(x,y,55,74,1,img_KS);
				break;
		}		
	}

}
//*************************************************************************************
// DisplayPlayerHand
// draw player hand
// place graphics here in future
//*************************************************************************************

void	DisplayPlayerHand()
{
	int x, result;

	// display player hand
	if( g_GameState >= GS_DEAL )
	{
		pgPrint(WINDOW_XPOS+110,170,0xffff, "Player Hand:", 0xFF);	
		for(x=0;x<PlayerCards;x++)
		{
	                      DisplayCard(x,1,(x*28)+WINDOW_XPOS+110,180);
		}
		
		pgPrint( WINDOW_XPOS+355, 20, 0xffff, "Cash  $", 0xFF );
		pgPrint( WINDOW_XPOS+415, 20, 0xffff, NumberToAscii( g_Cash, s_StringBuffer ), 0xFF );
	
		pgPrint( WINDOW_XPOS+355, 30, 0xffff, "Bet   $", 0xFF );
		pgPrint( WINDOW_XPOS+420, 30, 0xffff, NumberToAscii( g_Bet, s_StringBuffer ), 0xFF );
		
		if ( checkdouble==1 )
		{
	    pgPrint( WINDOW_XPOS+355, 40, 0xffff, "RAISE $", 0xFF );
			pgPrint( WINDOW_XPOS+420, 40, 0xffff, NumberToAscii( g_Raise, s_StringBuffer ), 0xFF );
		}
	
		if (( g_Insurance != 0 )  && ( check_dealerblackjack != 2 ))
		{
	    pgPrint( WINDOW_XPOS+355, 50, 0xffff, "INSR  $", 0xFF );
			pgPrint( WINDOW_XPOS+430, 50, 0xffff, NumberToAscii( g_Insurance, s_StringBuffer ), 0xFF );
  		pgPrint( WINDOW_XPOS+355, 60, 0xffff, "Wager $", 0xFF );
	  	pgPrint( WINDOW_XPOS+420, 60, 0xffff, NumberToAscii( g_Bet + g_Insurance + g_Raise, s_StringBuffer ), 0xFF );

		
		}
    else
    
{
		pgPrint( WINDOW_XPOS+355, 60, 0xffff, "Wager $", 0xFF );
		pgPrint( WINDOW_XPOS+420, 60, 0xffff, NumberToAscii( g_Bet + g_Raise, s_StringBuffer ), 0xFF );
}


		result = CalcPlayer();
		pgPrint( 100+WINDOW_XPOS+110, 170, 0xffff, NumberToAscii( result, s_StringBuffer ), 0xFF );
	}

 
}

//*************************************************************************************
// DisplayDealerHand
// draw dealer hand
// place graphics here in future
//*************************************************************************************
void	DisplayDealerHand()
{
	int x, dealerscore;

	dealerscore = CalcDealer();

	// display dealer hand
	if( g_GameState <= GS_SHOWDEALER && g_GameState >= GS_DEAL )
	{
		pgPrint(WINDOW_XPOS,35,0xffff, "Dealer Hand:", 0xFF);	
		for(x=0;x<DealerCards;x++)
		{
	//		pgWaitVn(60*3);
			if( x == 0 )
			{
				//pgPrint((x*36)+WINDOW_XPOS,80,0xffff, "??", 0xFF);	
				DisplayCard(999,2,(x*28)+WINDOW_XPOS,45); // 999 = show back
			} else {
				//pgPrint((x*36)+WINDOW_XPOS,80,0xffff, dealerdeck[x], 0xFF);	
				
				// hide second if ace
				
				
				DisplayCard(x,2,(x*28)+WINDOW_XPOS,45);
			}
		}

		// dont show card total
		pgPrint( 100+WINDOW_XPOS, 35, 0xffff, "?", 0xFF );
	}
	else if( g_GameState >= GS_DEAL )
	{
		pgPrint(WINDOW_XPOS,35,0xffff, "Dealer Hand:", 0xFF);	
		for(x=0;x<DealerCards;x++)
		{
		//	pgWaitVn(60*1);
			//pgPrint((x*36)+WINDOW_XPOS,80,0xffff, dealerdeck[x], 0xFF);	
			DisplayCard(x,2,(x*56)+WINDOW_XPOS,45);		}
		pgPrint( 100+WINDOW_XPOS, 35, 0xffff, NumberToAscii( dealerscore, s_StringBuffer ), 0xFF );
	}
     

}



//*************************************************************************************
// DoDealerTurn
// play dealers hand in auto mode or step mode
//*************************************************************************************
void	DoDealerTurn()
{
	int result;
  int result2;
	result = CalcDealer();
	result2 = CalcPlayer();
//	if ( result2 > 21 )					
//{	{
//			g_GameCmd=GS_RESULTS;		// finished dealer turn			
		
//	}	
	if( g_automode == 1 )
	{
    if ( result2 > 21 )
		{
			g_GameCmd=GS_RESULTS;	
		}
		else if ( PlayerCards == 5 && result2 <= 21 )
			{
				g_GameCmd=GS_RESULTS;	
			}
		else
		{		while( result < 17 )			
		{
			DrawCard(2);				
			result = CalcDealer();
		}
		g_GameCmd=GS_RESULTS;		// finished dealer turn
	  }
	}
	else
	{
		if( result >= 17 )
		{
			g_GameCmd=GS_RESULTS;		// finished dealer turn			
		}
		// dont change game state
	}// }
}

//*************************************************************************************
// CacheKey
// Main Key Handler
// Uses g_GameCmd and g_GameState to determine what to do
//*************************************************************************************

void	CacheKey()
{
	u32 testkey;

	testkey = CTRL_GetKey();

	if( testkey != 0 && g_CacheKey == 0 )
	{
		g_CacheKey = testkey;
	}

}


//*************************************************************************************
// ProcessInput
// Main Key Handler
// Uses g_GameCmd and g_GameState to determine what to do
//*************************************************************************************


void	ProcessInput()
{
	int result,x;
	u32	testkey;

	if( g_CacheKey != 0 )
	{
		testkey = g_CacheKey;
		g_CacheKey=0;
	}
	else
	{
		testkey = CTRL_GetKey();
	}
	
		// Key Handler
		if ( testkey & KEY_START )
		{
			g_GameCmd = GS_EXITGAME;			
		
		}
		else if ( testkey & KEY_LEFT )
		{								
			if( lastkey != testkey )
			{
				if( g_GameState == GS_BET )
				{				
					if( g_Bet )
					{
						g_Bet--;		
					}
				}
				//allow quick scroll
				//lastkey = testkey;
			}

		}

		
		else if ( testkey & KEY_RIGHT )
		{			
			if( lastkey != testkey )
			{
				if( g_GameState == GS_BET )
				{
					if( g_Bet < g_Cash )
					{
						g_Bet++;		
					}
				}
				//allow quick scroll
				//lastkey = testkey;
			}

		}
		else if ( testkey & KEY_UP )
		{								
			if( lastkey != testkey )
			{
				if( g_GameState == GS_BET )
				{				
					if( g_Bet+100 <= g_Cash )
					{
						g_Bet+=100;
					}
				}
				//lastkey = testkey;
			}
		
	
		}
		else if ( testkey & KEY_DOWN )
		{			
			if( lastkey != testkey )
			{
				if( g_GameState == GS_BET )
				{				
					if( g_Bet >= 100 )
					{
						g_Bet-=100;		
					}
				}
				//lastkey = testkey;
			}		

							
		}
		else if ( testkey & KEY_RTRIGGER )
		{
			// cheat - add $1000
			if( lastkey != KEY_RTRIGGER )
			{
				g_Cash += g_CheatCash;				
				lastkey = KEY_RTRIGGER;
			}
						
		}
		else if ( testkey & KEY_LTRIGGER )
		{
			// reset to starting cash $5000
			if( lastkey != KEY_LTRIGGER )
			{
				g_Cash = g_StartCash;				
				lastkey = KEY_LTRIGGER;
			}
						
		}

		else if ( testkey & KEY_CROSS )
		{
			if( lastkey != KEY_CROSS )
			{				
				if( g_GameState == GS_PLAYERTURN )
				{					
					// hit	
					if ( insur_instructions != 1 )				
					{
					DrawCard(1);										
				  }
				}
				else if( g_GameState == GS_BET )
				{
					if( g_Bet > 0 )
					{
						g_GameCmd = GS_STOREBET;
					}
				}
				else if( g_GameState == GS_DEALERTURN )
				{
					if( CalcDealer() < 17 )
					{
						DrawCard(2);				
				//		pgPrint( WINDOW_XPOS, 200, 0xffff, "Dealer Hits", 0xFF );
					} else {
				//		pgPrint( WINDOW_XPOS, 200, 0xffff, "Dealer Stands", 0xFF );
					}
					result = CalcDealer();
					if( result < 17 )
					{
						g_GameCmd = GS_REFRESH;
					}
					else
					{
						g_GameCmd = GS_RESULTS;
					}
				}
				else if( g_GameState == GS_RESULTS )
				{
					g_GameState = GS_INIT;
					g_GameCmd=GS_PAYOFF;		//restart game
					// move cards to trash pile
					
					if ( g_Winner == 2 )
						{
						dealw=dealw+1;
						}
					if ( checkdouble == 1 )
					{
							checkdouble =0;
					}	
					checktie=0;



					for(x=0;x<PlayerCards;x++)
					{
						decktrash[TrashCards][0] = playerdeck[x][0];
						decktrash[TrashCards][1] = playerdeck[x][1];
						decktrash[TrashCards][2] = playerdeck[x][2];
						TrashCards++;
					}	
					for(x=0;x<DealerCards;x++)
					{
						decktrash[TrashCards][0] = dealerdeck[x][0];
						decktrash[TrashCards][1] = dealerdeck[x][1];
						decktrash[TrashCards][2] = dealerdeck[x][2];
						TrashCards++;
					}
				}
				else if( g_GameState == GS_SHOWDEALER )
				{
					g_GameCmd = GS_SHOWDEALER;
				}
				else if( g_GameState >= GS_PAYOFF )
				{
					g_GameState=GS_INIT;
					g_GameCmd=GS_BET;	// restart game
				}
				lastkey = KEY_CROSS;
			}
			
		}
		else if ( testkey & KEY_CIRCLE )
		{
			if( lastkey != KEY_CIRCLE )
			{
				if( g_GameState == GS_PLAYERTURN )
				{		
					
					if ( insur_instructions != 1 )							
					{
					g_automode = 1;					
					g_GameCmd=GS_SHOWDEALER;
				  }
				} 
				else if( g_GameState == GS_DEALERTURN || g_GameState == GS_SHOWDEALER )
				{
					g_automode = 1;
					g_GameCmd = GS_SHOWDEALER;
				} 
				lastkey=KEY_CIRCLE;
			}
		}
		
		else if ( testkey & KEY_SQUARE )
		{
			//if( lastkey != KEY_SQUARE )
			//{
				if( insur == 'A' )
				{									
					if (insur_count == 0)
					{
						if( ( g_Bet / 2 ) < g_Cash )
					 	{
							g_Insurance =( g_Bet / 2 );		
							g_Cash -= g_Insurance;
				   	 insur_count = 1;
				   	 check_dealerblackjack = 1;
				   	 g_GameCmd = GS_PLAYERTURN;
				   	}
				  }
			   
				 lastkey=0; // }
			//	lastkey=KEY_SQUARE;
				}	
		}
		
		else if ( testkey & KEY_TRIANGLE )
		{
     // if( lastkey != KEY_TRIANGLE)
		//	{
			    if( ( PlayerCards == 2) && ( insur == 'A' ) )
			    {	
			    	insur_count = 1;
			    	check_dealerblackjack = 1;
			    	g_GameCmd = GS_PLAYERTURN;
			    }
   		    else if ( PlayerCards == 2 )
			       {
									if( g_Bet <= g_Cash )
									{
									g_Cash -= g_Bet;
									g_Raise = g_Bet;
									checkdouble=1;
									DrawCard(1);
    							g_automode = 1;
		      				g_GameCmd = GS_DEALERTURN;
									}
				     }
		
		lastkey=0; 
		}
		
		
		
		else
		{
			lastkey=0;
			//lastkey = KEY_TRIANGLE;
		}	

                }



//*************************************************************************************
// DetermineWinner
// display winner results
//*************************************************************************************
void	DetermineWinner()
{
	int playerscore, result, dealerscore;
	
        

        u32 result32;
	
		playerscore = CalcPlayer();
		result = playerscore;
		if( playerscore > 21 )
		{
			playerscore=0;
		}

		dealerscore = CalcDealer();
		result = dealerscore;
		if( dealerscore > 21 )
		{
			dealerscore=0;
		}

    if( dealerscore > playerscore )
		{
		  if( playerscore == 0 )
				{
        pgPrint( WINDOW_XPOS+110-50, 130, 0xffff, "Player Busted! Dealer Wins!", 0xFF );
       	} 
      else
      	{
				if( dealerscore == 21 && DealerCards == 2 )
					{
		  			if ( (PlayerCards == 5) && (playerscore <= 21) && (playerscore !=0))
			   			{
							pgPrint( WINDOW_XPOS+110-50, 130, 0xffff, "5 Cards! Player Wins!", 0xFF );
   		  	    pgPrint(WINDOW_XPOS+110-50, 140, 0xffff, "You win $",0xFF);
  		  	    pgPrint( WINDOW_XPOS+200-50, 140, 0xffff, NumberToAscii( g_Bet+g_Bet, s_StringBuffer ), 0xFF );
			  			g_Winner=1;
			  			}
						else if (( g_Insurance != 0 ) && (insur == 'A'))
							{				
						  pgPrint( WINDOW_XPOS+110-50, 130, 0xffff, "Dealer Blackjack and Insurance!", 0xFF );
   		  	    pgPrint(WINDOW_XPOS+110-50, 140, 0xffff, "You win $",0xFF);
  		  	    pgPrint( WINDOW_XPOS+200-50, 140, 0xffff, NumberToAscii( g_Bet+g_Bet+g_Insurance +g_Insurance, s_StringBuffer ), 0xFF );
						   g_Winner=1;
						  }
				  	else
			  			{
				    	pgPrint( WINDOW_XPOS+110-50, 130, 0xffff, "Dealer has BlackJack!", 0xFF );
				   	  pgPrint(WINDOW_XPOS+110-50, 140, 0xffff, "You lose $",0xFF);
			        pgPrint( WINDOW_XPOS+200-50, 140, 0xffff, NumberToAscii( g_Bet+g_Raise+g_Insurance, s_StringBuffer ), 0xFF );
	  	        g_Winner=2;
				   	  }
			    }	
        }
        
        
        
		  if ( (PlayerCards == 5) && (playerscore <= 21) && (playerscore !=0))
				{
		    pgPrint( WINDOW_XPOS+110-50, 130, 0xffff, "5 Cards! Player Wins!", 0xFF );
   		  pgPrint(WINDOW_XPOS+110-50, 140, 0xffff, "You win $",0xFF);
  		  pgPrint( WINDOW_XPOS+200-50, 140, 0xffff, NumberToAscii( g_Bet+g_Bet+g_Raise+g_Raise, s_StringBuffer ), 0xFF );
			  g_Winner=1;
				}
      else if (( g_Insurance != 0 ) && (insur == 'A') && ( dealerscore == 21 ))
			  {
	      pgPrint(WINDOW_XPOS+110-50, 140, 0xffff, "You win $",0xFF);
			  pgPrint( WINDOW_XPOS+200-50, 140, 0xffff, NumberToAscii( g_Bet+g_Bet +g_Insurance+g_Insurance, s_StringBuffer ), 0xFF );
	  	  g_Winner=1;
	   		}
			else		   
        {
			    pgPrint(WINDOW_XPOS+110-50, 140, 0xffff, "You lose $",0xFF);
			    pgPrint( WINDOW_XPOS+200-50, 140, 0xffff, NumberToAscii( g_Bet+g_Raise+g_Insurance, s_StringBuffer ), 0xFF );
	  	    g_Winner=2;
			  }
		}
// All OK above		
		else if( playerscore > dealerscore )
		{
				if ( PlayerCards == 5 && playerscore <= 21 && playerscore !=0)
				  {
					pgPrint( WINDOW_XPOS+110-50, 130, 0xffff, "5 Cards! Player Wins!", 0xFF );
          pgPrint(WINDOW_XPOS+110-50, 140, 0xffff, "You win $",0xFF);
  	 		  pgPrint( WINDOW_XPOS+190-50, 140, 0xffff, NumberToAscii( g_Bet+g_Raise+g_Bet+g_Raise, s_StringBuffer ), 0xFF );
				  }
				else 
				  {
				  pgPrint(WINDOW_XPOS+110-50, 140, 0xffff, "You win $",0xFF);			
				  if( playerscore == 21 && PlayerCards == 2 )
		  		  {
					  pgPrint( WINDOW_XPOS+110-50, 130, 0xffff, "Blackjack! Player Wins!", 0xFF );
					  result32 = g_Bet*3;  // bj 3	was /2 and 1.5 payoffcomes out 1275 but display 1500			
					pgPrint( WINDOW_XPOS+190-50, 140, 0xffff, NumberToAscii( result32, s_StringBuffer ), 0xFF );
			    	}
				  else if( dealerscore == 0 )
				    {
					  pgPrint( WINDOW_XPOS+110-50, 130, 0xffff, "Dealer Busts! Player Wins!", 0xFF );
					  pgPrint( WINDOW_XPOS+190-50, 140, 0xffff, NumberToAscii( g_Bet+g_Raise+g_Bet+g_Raise, s_StringBuffer ), 0xFF );
				    }
				  else
				    {
					  pgPrint( WINDOW_XPOS+110-50, 130, 0xffff, "Dealer Stands. Player Wins!", 0xFF );
					  pgPrint( WINDOW_XPOS+190-50, 140, 0xffff, NumberToAscii( g_Bet+g_Raise+g_Bet+g_Raise, s_StringBuffer ), 0xFF );
				    }
				  
		      }
		    g_Winner = 1;  
	}
	// all OK
		else
		{
				if( playerscore == 0 )
					{
					pgPrint( WINDOW_XPOS+110-50, 220-90, 0xffff, "Dealer Busts! Player Busted!", 0xFF );
		//			g_Winner=2;	// lost money no winner, faked with 2
					pgPrint(WINDOW_XPOS+110-50, 230-90, 0xffff, "You lose $",0xFF);
					pgPrint( WINDOW_XPOS+90+110-50, 230-90, 0xffff, NumberToAscii( g_Bet+g_Raise+g_Insurance, s_StringBuffer ), 0xFF );
					}
				else
					{
					pgPrint( WINDOW_XPOS+110-50, 220-90, 0xffff, "Tie! Player Pushes!", 0xFF );				
					checktie=1;
			//		g_Winner=0;
					}
			g_Winner = 0;
		}	
		
}

//*************************************************************************************
// CalcPlayer
// calc players hand
//*************************************************************************************
int CalcPlayer(void)
{
	int Score=0;
	int Aces=0;
	int x=0;
	char num;
	int charnum;

	for(x=0;x<PlayerCards;x++)
	{
		num = playerdeck[x][0];	// card value				

		//if( num == 65 )
		if( num == 'A' )
		{
			Aces++;
			charnum=11;		
		}
		//else if( num == 74 || num == 81 || num == 75 )
		else if( num == 'J' || num == 'Q' || num == 'K' )
		{
			Score += 10;
			charnum=10;
		}				
		else
		{		
			num-=48;
			if( num == 1 )
			{
				num=10;				
			}		
			charnum=num;
			Score += num;		
		}		
	}

	if( Aces > 0 )
	{
		if( Aces == 2 && Score == 0 )
		{
			Score=12;
		}
		else if( Score + 11 > 21 || Aces > 2 )
		{
			do {
				Score++;
				Aces--;			
			} while( Aces > 0 );	
		}
		else
		{
			Score+=11;
			Aces--;
			if( Aces > 0 )
			{
				Score++;
				Aces--;
			}
		}
	}
	return Score;
}

//*************************************************************************************
// CalcDealer
// calc dealers hand
//*************************************************************************************
int CalcDealer(void)
{
	int Score=0;
	int Aces=0;
	int x=0;	
	char num;
	int charnum;

	for(x=0;x<DealerCards;x++)
	{
		num = dealerdeck[x][0];	// card value				

		//if( num == 65 )
		if( num == 'A' )
		{
			Aces++;
			charnum=11;
		}
		//else if( num == 74 || num == 81 || num == 75 )
		else if( num == 'J' || num == 'Q' || num == 'K' )
		{
			Score += 10;
			charnum=10;
		}				
		else
		{		
			num-=48;
			if( num == 1 )
			{
				num=10;				
			}		
			charnum=num;
			Score += num;		
		}		
	}

	if( Aces > 0 )
	{
		if( Aces == 2 && Score == 0 )
		{
			Score=12;
		}
		else if( Score + 11 > 21 || Aces > 2 )
		{
			do {
				Score++;
				Aces--;			
			} while( Aces > 0 );	
		}
		else
		{
			Score+=11;
			Aces--;
			if( Aces > 0 )
			{
				Score++;
				Aces--;
			}
		}
	}
	return Score;
}

//*************************************************************************************
// BuildDeck
// builds the play deck from the master deck
//*************************************************************************************
void BuildDeck(void)
{
	int x;

	// build deck from master deck
	for( x=0;x<156;x++)
	{		
		playdeck[x][0] = deck[x][0];
		playdeck[x][1] = deck[x][1];
		playdeck[x][2] = deck[x][2];

	}
	DeckCards = 156;
	TrashCards=0;
	PlayerCards=0;
	DealerCards=0;
}

//*************************************************************************************
// DrawCard
// grabs next avail card from play deck
// will reshuffle trashcards (pile) back
// into play deck if necessary.
//*************************************************************************************
void DrawCard(int player)
{
	int x, num, trashcnt;

	if( DeckCards == 0 )
	{
		// fill play deck with trash pile
		trashcnt = TrashCards;
		for(x=0;x<trashcnt;x++)
		{
			playdeck[DeckCards][0] = decktrash[x][0];
			playdeck[DeckCards][1] = decktrash[x][1];
			playdeck[DeckCards][2] = decktrash[x][2];
			DeckCards++;
			TrashCards--;
		}
		// need to reshuffle 5x
		for(x=0;x<5;x++)
		{
			PlayDeckShuffle();
		}
		// Below is to add cards in player hand back into the
		// play deck to draw on the debug screen only.
		// when re-building a new playdeck cards in player & dealer
		// hand will not be drawn in the original draw order.
		// shortcut taken since it's for debug only
		num=0;
		for(x=0;x<PlayerCards;x++)
		{			
			playdeck[DeckCards+num][0] = playerdeck[x][0];
			playdeck[DeckCards+num][1] = playerdeck[x][1];
			playdeck[DeckCards+num][2] = playerdeck[x][2];
			num++;
		}
		for(x=0;x<DealerCards;x++)
		{			
			playdeck[DeckCards+num][0] = dealerdeck[x][0];
			playdeck[DeckCards+num][1] = dealerdeck[x][1];
			playdeck[DeckCards+num][2] = dealerdeck[x][2];
			num++;
		}
	}
	
	// moves card pointer to next avail card - do first since
	// ptr starts at 52 not 51 :)
	DeckCards--;	

	// grab card from play deck and play in players hand
	// 1=player, 2=dealer
	if( player == 1 )
	{
		playerdeck[PlayerCards][0] = playdeck[DeckCards][0];
		playerdeck[PlayerCards][1] = playdeck[DeckCards][1];
		playerdeck[PlayerCards][2] = playdeck[DeckCards][2];
		PlayerCards++;
	} 
	else if( player == 2 )
	{
		dealerdeck[DealerCards][0] = playdeck[DeckCards][0];
		dealerdeck[DealerCards][1] = playdeck[DeckCards][1];
		dealerdeck[DealerCards][2] = playdeck[DeckCards][2];
		DealerCards++;
	}	
}

//*************************************************************************************
// PlayDeckShuffle
// reshuffle the play deck - when were out of cards yet cards
// are still in play by player and dealer.
//*************************************************************************************
void PlayDeckShuffle(void)
{
	int x, num;

	for( x=0;x<DeckCards;x++)
	{
		num = rand();
		num = (num % (156-1));			
		decktemp[0][0] = playdeck[x][0];
		decktemp[0][1] = playdeck[x][1];
		decktemp[0][2] = playdeck[x][2];

		playdeck[x][0] = playdeck[num][0];
		playdeck[x][1] = playdeck[num][1];
		playdeck[x][2] = playdeck[num][2];

		playdeck[num][0] = decktemp[0][0];
		playdeck[num][1] = decktemp[0][1];
		playdeck[num][2] = decktemp[0][2];
	}

}

//*************************************************************************************
// MasterShuffle
// first time shuffle with all cards
//*************************************************************************************
void MasterShuffle(void)
{
	int x, num;

	// swap up cards
	for( x=0;x<156;x++)
	{
		num = rand();
		num = (num % (156-1));			
		decktemp[0][0] = playdeck[x][0];
		decktemp[0][1] = playdeck[x][1];
		decktemp[0][2] = playdeck[x][2];

		playdeck[x][0] = playdeck[num][0];
		playdeck[x][1] = playdeck[num][1];
		playdeck[x][2] = playdeck[num][2];

		playdeck[num][0] = decktemp[0][0];
		playdeck[num][1] = decktemp[0][1];
		playdeck[num][2] = decktemp[0][2];
	}

}


//*************************************************************************************
// xmain
// main looped routine
//*************************************************************************************
int		xmain()
{


	//s32		fps, last_frame;


  insur_count = 0;
  check_dealerblackjack = 0;


	g_StartTick = sceKernelLibcClock();

	g_GameState=0;
	g_GameCmd=0;
  dealw=0;
	playw=0;
	tiew=0;
	srand(sceKernelLibcClock());
    
	pgInit();
//	 pgBitBlt(0,20,348,247,1,img_Background);	
	pgScreenFrame( 2, 0 );

	pgFillvram( 0x0000 );
	pgScreenFlipV();
 


//	pgFillvram( 0x0000 );
	//pgScreenFlipV();
	
	//last_frame = fps = sceKernelLibcClock();
	
	BuildDeck();
	MasterShuffle(); // reshuffle 3 times
	MasterShuffle();
	MasterShuffle();

	g_GameState=GS_INIT;	
	g_GameCmd = GS_INIT;

	g_StartTick = sceKernelLibcClock();

	while ( 1 )
	{
		ProcessGameCmd();
		ProcessInput();

		if( g_GameCmd == GS_EXITGAME )
		{
			
			break;
		}
	}

	return 0;
}

//*************************************************************************************
// pgExit
// Exit Routine	
//*************************************************************************************
void pgExit( int n )
{
	__exit();
}

//*************************************************************************************
// pgMain
//Main Starter 
//*************************************************************************************
void	pgMain( unsigned long args, void * argp )
{
//	SetupCallbacks();  // Init Home Button
	int ret = xmain();
	pgExit( ret );
}

